package models

type DoctorAdvice struct {
	ID                    int64           `gorm:"column:id" json:"id" form:"id"`
	GroupNo               int64           `gorm:"column:groupno" json:"groupno" form:"groupno"`
	UserOrgId             int64           `gorm:"column:user_org_id" json:"user_org_id" form:"user_org_id"`
	PatientId             int64           `gorm:"column:patient_id" json:"patient_id" form:"patient_id"`
	AdviceType            int64           `gorm:"column:advice_type" json:"advice_type" form:"advice_type"`
	AdviceDate            int64           `gorm:"column:advice_date" json:"advice_date" form:"advice_date"`
	StartTime             int64           `gorm:"column:start_time" json:"start_time" form:"start_time"`
	AdviceName            string          `gorm:"column:advice_name" json:"advice_name" form:"advice_name"`
	AdviceDesc            string          `gorm:"column:advice_desc" json:"advice_desc" form:"advice_desc"`
	ReminderDate          int64           `gorm:"column:reminder_date" json:"reminder_date" form:"reminder_date"`
	SingleDose            float64         `gorm:"column:single_dose" json:"single_dose" form:"single_dose"`
	SingleDoseUnit        string          `gorm:"column:single_dose_unit" json:"single_dose_unit" form:"single_dose_unit"`
	DrugSpec              float64         `gorm:"column:drug_spec" json:"drug_spec" form:"drug_spec"`
	DrugSpecUnit          string          `gorm:"column:drug_spec_unit" json:"drug_spec_unit" form:"drug_spec_unit"`
	PrescribingNumber     float64         `gorm:"column:prescribing_number" json:"prescribing_number" form:"prescribing_number"`
	PrescribingNumberUnit string          `gorm:"column:prescribing_number_unit" json:"prescribing_number_unit" form:"prescribing_number_unit"`
	DeliveryWay           string          `gorm:"column:delivery_way" json:"delivery_way" form:"delivery_way"`
	ExecutionFrequency    string          `gorm:"column:execution_frequency" json:"execution_frequency" form:"execution_frequency"`
	AdviceDoctor          int64           `gorm:"column:advice_doctor" json:"advice_doctor" form:"advice_doctor"`
	Status                int64           `gorm:"column:status" json:"status" form:"status"`
	CreatedTime           int64           `gorm:"column:created_time" json:"created_time" form:"created_time"`
	UpdatedTime           int64           `gorm:"column:updated_time" json:"updated_time" form:"updated_time"`
	AdviceAffirm          string          `gorm:"column:advice_affirm" json:"advice_affirm" form:"advice_affirm"`
	Remark                string          `gorm:"column:remark" json:"remark" form:"remark"`
	StopTime              int64           `gorm:"column:stop_time" json:"stop_time" form:"stop_time"`
	StopReason            string          `gorm:"column:stop_reason" json:"stop_reason" form:"stop_reason"`
	StopDoctor            int64           `gorm:"column:stop_doctor" json:"stop_doctor" form:"stop_doctor"`
	StopState             int64           `gorm:"column:stop_state" json:"stop_state" form:"stop_state"`
	ParentId              int64           `gorm:"column:parent_id" json:"parent_id" form:"parent_id"`
	ExecutionTime         int64           `gorm:"column:execution_time" json:"execution_time" form:"execution_time"`
	ExecutionStaff        int64           `gorm:"column:execution_staff" json:"execution_staff" form:"execution_staff"`
	ExecutionState        int64           `gorm:"column:execution_state" json:"execution_state" form:"execution_state"`
	Checker               int64           `gorm:"column:checker" json:"checker" form:"checker"`
	RecordDate            int64           `gorm:"column:record_date" json:"record_date"`
	DialysisOrderId       int64           `gorm:"column:dialysis_order_id" json:"dialysis_order_id"`
	CheckTime             int64           `gorm:"column:check_time" json:"check_time" form:"check_time"`
	CheckState            int64           `gorm:"column:check_state" json:"check_state" form:"check_state"`
	AdviceId              int64           `gorm:"-"`
	RemindType            int64           `gorm:"column:remind_type" json:"remind_type"`
	FrequencyType         int64           `gorm:"column:frequency_type" json:"frequency_type"`
	DayCount              int64           `gorm:"column:day_count" json:"day_count"`
	WeekDay               string          `gorm:"column:week_day" json:"week_day"`
	ChildDoctorAdvice     []*DoctorAdvice `gorm:"ForeignKey:ParentId;AssociationForeignKey:ID" json:"child"`
	TemplateId            string          `gorm:"column:template_id" json:"template_id"`
	Modifier              int64           `gorm:"column:modifier" json:"modifier" form:"modifier"`
	IsCheck               int64           `gorm:"-" json:"is_check" form:"is_check"`
}

func (DoctorAdvice) TableName() string {
	return "xt_doctor_advice"
}

type FiledConfig struct {
	ID          int64  `gorm:"column:id" json:"id"`
	OrgId       int64  `gorm:"column:org_id" json:"org_id"`
	Module      int64  `gorm:"column:module" json:"module"`
	FiledName   string `gorm:"column:filed_name" json:"filed_name"`
	FiledNameCn string `gorm:"column:filed_name_cn" json:"filed_name_cn"`
	IsShow      int64  `gorm:"column:is_show" json:"is_show"`
	CreateTime  int64  `gorm:"column:create_time" json:"create_time"`
	UpdateTime  int64  `gorm:"column:update_time" json:"update_time"`
	SysModule   int64  `gorm:"column:sys_module" json:"sys_module" form:"sys_module"`
}

func (FiledConfig) TableName() string {
	return "xt_filed_config"
}

type MiddlePatients struct {
	ID             	int64 `gorm:"column:id" json:"id" form:"id"`
	UserOrgId		int64 `gorm:"column:user_org_id" json:"user_org_id" form:"user_org_id"`
	UserId       	int64 `gorm:"column:user_id" json:"user_id" form:"user_id"`
	HisUserId  		string `gorm:"column:his_user_id" json:"his_user_id" form:"his_user_id"`
	XtPatientId  	int64 `gorm:"column:xt_patient_id" json:"xt_patient_id" form:"xt_patient_id"`
	SelectType  	int64 `gorm:"column:select_type" json:"select_type" form:"select_type"`
	Status 			int	  `gorm:"column:status" json:"status" form:"status"`

}

func (MiddlePatients) TableName() string {
	return "xt_middle_patients"
}

type Patients struct {
	ID				int64	`gorm:"column:id" json:"id" form:"id"`
	UserOrgId		int64	`gorm:"column:user_org_id" json:"user_org_id" form:"user_org_id"`
	UserId			int64	`gorm:"column:user_id" json:"user_id" form:"user_id"`
	AdmissionNumber	string	`gorm:"column:admission_number" json:"admission_number" form:"admission_number"`
	DialysisNo		string	`gorm:"column:dialysis_no" json:"dialysis_no" form:"dialysis_no"`
	IdCardNo		string	`gorm:"column:id_card_no" json:"id_card_no" form:"id_card_no"`
	Name			string	`gorm:"column:name" json:"name" form:"name"`
	ContactName		string	`gorm:"column:contact_name" json:"contact_name" form:"contact_name"`
}

func (Patients) TableName() string {
	return "xt_patients"
}

type DialysisSchedule struct {
	ID           int64 `gorm:"column:id" json:"id" form:"id"`
	UserOrgId    int64 `gorm:"column:user_org_id" json:"user_org_id" form:"user_org_id"`
	PartitionId  int64 `gorm:"column:partition_id" json:"partition_id" form:"partition_id"`
	BedId        int64 `gorm:"column:bed_id" json:"bed_id" form:"bed_id"`
	PatientId    int64 `gorm:"column:patient_id" json:"patient_id" form:"patient_id"`
	ScheduleDate int64 `gorm:"column:schedule_date" json:"schedule_date" form:"schedule_date"`
	ScheduleType int64 `gorm:"column:schedule_type" json:"schedule_type" form:"schedule_type"`
	ScheduleWeek int64 `gorm:"column:schedule_week" json:"schedule_week" form:"schedule_week"`
	ModeId       int64 `gorm:"column:mode_id" json:"mode_id" form:"mode_id"`
	Status       int64 `gorm:"column:status" json:"status" form:"status"`
	CreatedTime  int64 `gorm:"column:created_time" json:"created_time" form:"created_time"`
	UpdatedTime  int64 `gorm:"column:updated_time" json:"updated_time" form:"updated_time"`
	Patients Patients `gorm:"ForeignKey:PatientId" json:"patient"`
}

func (DialysisSchedule) TableName() string {
	return "xt_schedule"
}


type MiddleSyncInfo struct {
	ID             	int64 `gorm:"column:id" json:"id" form:"id"`
	OrgId       	int64 `gorm:"column:org_id" json:"org_id" form:"org_id"`
	HisUserId       string `gorm:"column:his_user_id" json:"his_user_id" form:"his_user_id"`
	SyncTime       	int64 `gorm:"column:sync_time" json:"sync_time" form:"sync_time"`
	SyncResultType  int	  `gorm:"column:sync_result_type" json:"sync_result_type" form:"sync_result_type"`
	SyncRsultRemark string `gorm:"column:sync_result_remark" json:"sync_result_remark" form:"sync_result_remark"`
	SyncTotalNum    int64 `gorm:"column:sync_total_num" json:"sync_total_num" form:"sync_total_num"`
	SyncSuccessNum  int64 `gorm:"column:sync_success_num" json:"sync_success_num" form:"sync_success_num"`
	SyncInfo      	string `gorm:"column:sync_info" json:"sync_info" form:"sync_info"`
	CreateTime      int64 `gorm:"column:create_time" json:"create_time" form:"create_time"`
	UpdateTime    	int64 `gorm:"column:update_time" json:"update_time" form:"update_time"`
}

func (MiddleSyncInfo) TableName() string {
	return "xt_middle_sync_info"
}

type TBLISItem struct {
	HisUserId             	string  `gorm:"column:his_user_id" json:"his_user_id" form:"his_user_id"`
	ProjectId       		int64  `gorm:"column:project_id" json:"project_id" form:"project_id"`
	ProjectName         	string `gorm:"column:project_name" json:"project_name" form:"project_name"`
	PatientName         	string `gorm:"column:patient_name" json:"patient_name" form:"patient_name"`
	InspectDate          	string  `gorm:"column:inspect_date" json:"inspect_date" form:"inspect_date"`
	ItemId           		int64 `gorm:"column:item_id" json:"item_id" form:"item_id"`
	ItemName      			string `gorm:"column:item_name" json:"item_name" form:"item_name"`
	ItemType          		int    `gorm:"column:item_type" json:"item_type" form:"item_type"`
	ItemValue    			string `gorm:"column:item_value" json:"item_value" form:"item_value"`
	RangeMin    			string `gorm:"column:range_min" json:"range_min" form:"range_min"`
	RangeMax    			string `gorm:"column:range_max" json:"range_max" form:"range_max"`
	RangeValue   			string  `gorm:"column:range_value" json:"range_value" form:"range_value"`
	RangeOptions         	string  `gorm:"column:range_options" json:"range_options" form:"range_options"`
	Unit         			string `gorm:"column:unit" json:"unit" form:"unit"`
	UTime 					string  `gorm:"column:u_time" json:"u_time" form:"u_time"`
}

func (TBLISItem) TableName() string {
	return "TB_LIS_Item"
}

type Inspection struct {
	ID int64 `gorm:"column:id" json:"id" form:"id"`
	PatientId int64 `gorm:"column:patient_id" json:"patient_id" form:"patient_id"`
	OrgId int64 `gorm:"column:org_id" json:"org_id" form:"org_id"`
	ProjectId int64 `gorm:"column:project_id" json:"project_id" form:"project_id"`
	ItemId int64 `gorm:"column:item_id" json:"item_id" form:"item_id"`
	ItemName string `gorm:"column:item_name" json:"item_name" form:"item_name"`
	ProjectName string `gorm:"column:project_name" json:"project_name" form:"project_name"`
	InspectType int64 `gorm:"column:inspect_type" json:"inspect_type" form:"inspect_type"`
	InspectValue string `gorm:"column:inspect_value" json:"inspect_value" form:"inspect_value"`
	InspectTips string `gorm:"column:inspect_tips" json:"inspect_tips" form:"inspect_tips"`
	InspectDate int64 `gorm:"column:inspect_date" json:"inspect_date" form:"inspect_date"`
	Status int64 `gorm:"column:status" json:"status" form:"status"`
	CreatedTime int64 `gorm:"column:created_time" json:"created_time" form:"created_time"`
	UpdatedTime int64 `gorm:"column:updated_time" json:"updated_time" form:"updated_time"`
}


func (Inspection) TableName() string {
	return "xt_inspection"
}

type InspectionReference struct {
	ID int64 `gorm:"column:id" json:"id" form:"id"`
	OrgId int64 `gorm:"column:org_id" json:"org_id" form:"org_id"`
	ProjectName string `gorm:"column:project_name" json:"project_name" form:"project_name"`
	Project string `gorm:"column:project" json:"project" form:"project"`
	ProjectId int64 `gorm:"column:project_id" json:"project_id" form:"project_id"`
	ItemName string `gorm:"column:item_name" json:"item_name" form:"item_name"`
	ItemNameAddition string `gorm:"column:item_name_addition" json:"item_name_addition" form:"item_name_addition"`
	Item string `gorm:"column:item" json:"item" form:"item"`
	ItemId int64 `gorm:"column:item_id" json:"item_id" form:"item_id"`
	RangeType int `gorm:"column:range_type" json:"range_type" form:"range_type"`
	RangeMin string `gorm:"column:range_min" json:"range_min" form:"range_min"`
	RangeMax string `gorm:"column:range_max" json:"range_max" form:"range_max"`
	RangeValue string `gorm:"column:range_value" json:"range_value" form:"range_value"`
	RangeOptions string `gorm:"column:range_options" json:"range_options" form:"range_options"`
	Unit string `gorm:"column:unit" json:"unit" form:"unit"`
	Status int64 `gorm:"column:status" json:"status" form:"status"`
	CreatedTime int64 `gorm:"column:created_time" json:"created_time" form:"created_time"`
	UpdatedTime int64 `gorm:"column:updated_time" json:"updated_time" form:"updated_time"`
}

func (InspectionReference) TableName() string {
	return "xt_inspection_reference"
}

type MiddleReportHandle struct {
	ID int64 `gorm:"column:id" json:"id" form:"id"`
	OrgId int64 `gorm:"column:org_id" json:"org_id" form:"org_id"`
	HisUserId string `gorm:"column:his_user_id" json:"his_user_id" form:"his_user_id"`
	ApplyNo string `gorm:"column:apply_no" json:"apply_no" form:"apply_no"`
	ReportId string `gorm:"column:report_id" json:"report_id" form:"report_id"`
	Name string `gorm:"column:name" json:"name" form:"name"`
	Sex string `gorm:"column:sex" json:"sex" form:"sex"`
	Age string `gorm:"column:age" json:"age" form:"age"`
	Dept string `gorm:"column:dept" json:"dept" form:"dept"`
	PatientId string `gorm:"column:patient_id" json:"patient_id" form:"patient_id"`
	RequestTime string `gorm:"column:request_time" json:"request_time" form:"request_time"`
	ExecuteTime string `gorm:"column:execute_time" json:"execute_time" form:"execute_time"`
	ReceiveTime string `gorm:"column:receive_time" json:"receive_time" form:"receive_time"`
	Item string `gorm:"column:item" json:"item" form:"item"`
	CheckTime string `gorm:"column:check_time" json:"check_time" form:"check_time"`
	PatientType string `gorm:"column:patient_type" json:"patient_type" form:"patient_type"`
	ReportInfo string `gorm:"column:report_info" json:"report_info" form:"report_info"`
	ReportInfoItemNum int64 `gorm:"column:report_info_item_num" json:"report_info_item_num" form:"report_info_item_num"`
	ReportInfoItemHandleNum int64 `gorm:"column:report_info_item_handle_num" json:"report_info_item_handle_num" form:"report_info_item_handle_num"`
	HandleType int64 `gorm:"column:handle_type" json:"handle_type" form:"handle_type"`
	CreatedTime int64 `gorm:"column:created_time" json:"created_time" form:"created_time"`
	UpdatedTime int64 `gorm:"column:updated_time" json:"updated_time" form:"updated_time"`
}


func (MiddleReportHandle) TableName() string {
	return "xt_middle_report_handle"
}

type MiddleInspection struct {
	ID int64 `gorm:"column:id" json:"id" form:"id"`
	PatientId int64 `gorm:"column:patient_id" json:"patient_id" form:"patient_id"`
	OrgId int64 `gorm:"column:org_id" json:"org_id" form:"org_id"`
	ProjectId int64 `gorm:"column:project_id" json:"project_id" form:"project_id"`
	ItemId int64 `gorm:"column:item_id" json:"item_id" form:"item_id"`
	ItemName string `gorm:"column:item_name" json:"item_name" form:"item_name"`
	ProjectName string `gorm:"column:project_name" json:"project_name" form:"project_name"`
	InspectType int `gorm:"column:inspect_type" json:"inspect_type" form:"inspect_type"`
	InspectValue string `gorm:"column:inspect_value" json:"inspect_value" form:"inspect_value"`
	InspectTips string `gorm:"column:inspect_tips" json:"inspect_tips" form:"inspect_tips"`
	RecordDate int64 `gorm:"column:record_date" json:"record_date" form:"record_date"`
	InspectDate string `gorm:"column:inspect_date" json:"inspect_date" form:"inspect_date"`
	Status int64 `gorm:"column:status" json:"status" form:"status"`
	CreatedTime int64 `gorm:"column:created_time" json:"created_time" form:"created_time"`
	UpdatedTime int64 `gorm:"column:updated_time" json:"updated_time" form:"updated_time"`
	UTime string `gorm:"column:u_time" json:"u_time" form:"u_time"`
	IsSync int `gorm:"column:is_sync" json:"is_sync" form:"is_sync"`
	// SyncItemId int64 `gorm:"column:sync_item_id" json:"sync_item_id" form:"sync_item_id"`
	HisUserId string `gorm:"column:his_user_id" json:"his_user_id" form:"his_user_id"`
	SyncId			int64 `gorm:"column:sync_id" json:"sync_id" form:"sync_id"`
}


func (MiddleInspection) TableName() string {
	return "xt_middle_inspection"
}

type MiddleInspectionReference struct {
	ID 					int64 `gorm:"column:id" json:"id" form:"id"`
	OrgId 				int64 `gorm:"column:org_id" json:"org_id" form:"org_id"`
	ProjectName 		string `gorm:"column:project_name" json:"project_name" form:"project_name"`
	Project 			string `gorm:"column:project" json:"project" form:"project"`
	ProjectId 			int64 `gorm:"column:project_id" json:"project_id" form:"project_id"`
	ItemName 			string `gorm:"column:item_name" json:"item_name" form:"item_name"`
	ItemId 				int64 `gorm:"column:item_id" json:"item_id" form:"item_id"`
	ItemNameAddition 	string `gorm:"column:item_name_addition" json:"item_name_addition" form:"item_name_addition"`
	Item 				string `gorm:"column:item" json:"item" form:"item"`
	RangeType 			int `gorm:"column:range_type" json:"range_type" form:"range_type"`
	RangeMin 			string `gorm:"column:range_min" json:"range_min" form:"range_min"`
	RangeMax 			string `gorm:"column:range_max" json:"range_max" form:"range_max"`
	RangeValue 			string `gorm:"column:range_value" json:"range_value" form:"range_value"`
	RangeOptions 		string `gorm:"column:range_options" json:"range_options" form:"range_options"`
	Unit 				string `gorm:"column:unit" json:"unit" form:"unit"`
	Status 				int64 `gorm:"column:status" json:"status" form:"status"`
	CreatedTime 		int64 `gorm:"column:created_time" json:"created_time" form:"created_time"`
	UpdatedTime 		int64 `gorm:"column:updated_time" json:"updated_time" form:"updated_time"`
	InspectDate 		string `gorm:"column:inspect_date" json:"inspect_date" form:"inspect_date"`
	IsSync 				int `gorm:"column:is_sync" json:"is_sync" form:"is_sync"`
	UTime 				string `gorm:"column:u_time" json:"u_time" form:"u_time"`
	SyncId				int64 `gorm:"column:sync_id" json:"sync_id" form:"sync_id"`
}

func (MiddleInspectionReference) TableName() string {
	return "xt_middle_inspection_reference"
}

type XtDoctorAdvice struct {
	ID                    int64   `gorm:"column:id" json:"id" form:"id"`
	UserOrgId             int64   `gorm:"column:user_org_id" json:"user_org_id" form:"user_org_id"`
	PatientId             int64   `gorm:"column:patient_id" json:"patient_id" form:"patient_id"`
	AdviceType            int64   `gorm:"column:advice_type" json:"advice_type" form:"advice_type"`
	AdviceDate            int64   `gorm:"column:advice_date" json:"advice_date" form:"advice_date"`
	StartTime             int64   `gorm:"column:start_time" json:"start_time" form:"start_time"`
	AdviceName            string  `gorm:"column:advice_name" json:"advice_name" form:"advice_name"`
	AdviceDesc            string  `gorm:"column:advice_desc" json:"advice_desc" form:"advice_desc"`
	ReminderDate          int64   `gorm:"column:reminder_date" json:"reminder_date" form:"reminder_date"`
	SingleDose            float64 `gorm:"column:single_dose" json:"single_dose" form:"single_dose"`
	SingleDoseUnit        string  `gorm:"column:single_dose_unit" json:"single_dose_unit" form:"single_dose_unit"`
	PrescribingNumber     float64 `gorm:"column:prescribing_number" json:"prescribing_number" form:"prescribing_number"`
	PrescribingNumberUnit string  `gorm:"column:prescribing_number_unit" json:"prescribing_number_unit" form:"prescribing_number_unit"`
	DeliveryWay           string  `gorm:"column:delivery_way" json:"delivery_way" form:"delivery_way"`
	ExecutionFrequency    string  `gorm:"column:execution_frequency" json:"execution_frequency" form:"execution_frequency"`
	AdviceDoctor          int64   `gorm:"column:advice_doctor" json:"advice_doctor" form:"advice_doctor"`
	Status                int64   `gorm:"column:status" json:"status" form:"status"`
	CreatedTime           int64   `gorm:"column:created_time" json:"created_time" form:"created_time"`
	UpdatedTime           int64   `gorm:"column:updated_time" json:"updated_time" form:"updated_time"`
	AdviceAffirm          string  `gorm:"column:advice_affirm" json:"advice_affirm" form:"advice_affirm"`
	Remark                string  `gorm:"column:remark" json:"remark" form:"remark"`
	StopTime              int64   `gorm:"column:stop_time" json:"stop_time" form:"stop_time"`
	StopReason            string  `gorm:"column:stop_reason" json:"stop_reason" form:"stop_reason"`
	StopDoctor            int64   `gorm:"column:stop_doctor" json:"stop_doctor" form:"stop_doctor"`
	StopState             int64   `gorm:"column:stop_state" json:"stop_state" form:"stop_state"`
	ParentId              int64   `gorm:"column:parent_id" json:"parent_id" form:"parent_id"`
	ExecutionTime         int64   `gorm:"column:execution_time" json:"execution_time" form:"execution_time"`
	ExecutionStaff        int64   `gorm:"column:execution_staff" json:"execution_staff" form:"execution_staff"`
	ExecutionState        int64   `gorm:"column:execution_state" json:"execution_state" form:"execution_state"`
	Checker               int64   `gorm:"column:checker" json:"checker" form:"checker"`
	RecordDate            int64   `gorm:"column:record_date" json:"record_date" form:"record_date"`
	DialysisOrderId       int64   `gorm:"column:dialysis_order_id" json:"dialysis_order_id" form:"dialysis_order_id"`
	CheckTime             int64   `gorm:"column:check_time" json:"check_time" form:"check_time"`
	CheckState            int64   `gorm:"column:check_state" json:"check_state" form:"check_state"`
	DrugSpec              float64 `gorm:"column:drug_spec" json:"drug_spec" form:"drug_spec"`
	DrugSpecUnit          string  `gorm:"column:drug_spec_unit" json:"drug_spec_unit" form:"drug_spec_unit"`
	Groupno               int64   `gorm:"column:groupno" json:"groupno" form:"groupno"`
	RemindType            int64   `gorm:"column:remind_type" json:"remind_type" form:"remind_type"`
	FrequencyType         int64   `gorm:"column:frequency_type" json:"frequency_type" form:"frequency_type"`
	DayCount              int64   `gorm:"column:day_count" json:"day_count" form:"day_count"`
	WeekDay               string  `gorm:"column:week_day" json:"week_day" form:"week_day"`
	TemplateId            string  `gorm:"column:template_id" json:"template_id" form:"template_id"`
	Modifier              int64   `gorm:"column:modifier" json:"modifier" form:"modifier"`
	SyncAdviceId          int64   `gorm:"column:sync_advice_id" json:"sync_advice_id" form:"sync_advice_id"`
	IsSync          	  int64   `gorm:"column:is_sync" json:"is_sync" form:"is_sync"`
}

func (XtDoctorAdvice) TableName() string {
	return "xt_doctor_advice"
}

type UserAdminRole struct {
	ID              int64           `gorm:"column:id" json:"id"`
	AdminUserId     int64           `gorm:"column:admin_user_id" json:"admin_user_id"`
	OrgId           int64           `gorm:"column:org_id" json:"org_id"`
	AppId           int64           `gorm:"column:app_id" json:"app_id"`
	RoleId          int64           `gorm:"column:role_id" json:"role_id"`
	UserName        string          `gorm:"column:user_name" json:"user_name"`
	Avatar          string          `gorm:"column:avatar" json:"avatar"`
	UserType        int64           `gorm:"column:user_type" json:"user_type"`
	UserTitle       int64           `gorm:"column:user_title" json:"user_title"`
	Intro           string          `gorm:"column:intro" json:"intro"`
	Status          int64           `gorm:"column:status" json:"status"`
	Ctime           int64           `gorm:"column:ctime" json:"ctime"`
	Mtime           int64           `gorm:"column:mtime" json:"mtime"`
}

func (UserAdminRole) TableName() string {
	return "sgj_user_admin_role"
}